//+------------------------------------------------------------------+
//|                                                      .mq4 |
//|                                              |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011,  .."
#property link      "alextar@bk.ru"
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Green    // 
#property indicator_width1 2
#property indicator_style1 STYLE_DASH
#property indicator_color2 Green
#property indicator_width2 2
#property indicator_style2 STYLE_DASH
#property indicator_color3 Red      // 
#property indicator_width3 2
#property indicator_style3 STYLE_DASH
#property indicator_color4 Red
#property indicator_width4 2
#property indicator_style4 STYLE_DASH
#property indicator_color5 Yellow   // 
#property indicator_width5 2
#property indicator_style5 STYLE_DOT
#property indicator_color6 Yellow
#property indicator_width6 2
#property indicator_style6 STYLE_DOT
#property indicator_color7 Blue     // 
#property indicator_width7 2
#property indicator_style7 STYLE_DASHDOTDOT
//--- input parameters
extern double SpeedMin=0,           //   ( )
              WidthMax=100;         //    
extern bool ShowAxe=false,          //   
            ShowTrend=true,
            ShowFlet=false;
extern int TotalBars=0,             //    
           TrendStyle=DRAW_LINE,    //   
           FletStyle=DRAW_LINE,     //      
           AxeStyle=DRAW_LINE,      //    
           TrendArrow=159,          //   
           FletArrow=159,           //      
           AxeArrow=159;            //    
double VeryBigValue, VerySmallValue, Shift;
//--- buffers
double UH[], UL[], DH[], DL[], FH[], FL[], Axe[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorShortName("");
   SetIndexStyle(0,TrendStyle);
   SetIndexLabel(0,"RaisingChannelTopBorder");
   SetIndexEmptyValue(0,0.0);
   SetIndexBuffer(0,UH);
   SetIndexStyle(1,TrendStyle);
   SetIndexLabel(1,"RaisingChannelBottomBorder");
   SetIndexEmptyValue(1,0.0);
   SetIndexBuffer(1,UL);
   SetIndexStyle(2,TrendStyle);
   SetIndexLabel(2,"RedusingChannelTopBorder");
   SetIndexEmptyValue(2,0.0);
   SetIndexBuffer(2,DH);
   SetIndexStyle(3,TrendStyle);
   SetIndexLabel(3,"RedusingChannelBottomBorder");
   SetIndexEmptyValue(3,0.0);
   SetIndexBuffer(3,DL);
   SetIndexStyle(4,FletStyle);
   SetIndexLabel(4,"FletChannelTopBorder");
   SetIndexEmptyValue(4,0.0);
   SetIndexBuffer(4,FH);
   SetIndexStyle(5,FletStyle);
   SetIndexLabel(5,"FletChannelBottomBorder");
   SetIndexEmptyValue(5,0.0);
   SetIndexBuffer(5,FL);
   SetIndexStyle(6,AxeStyle);
   SetIndexLabel(6,"AxeLine");
   SetIndexEmptyValue(6,0.0);
   SetIndexBuffer(6,Axe);
   if( TrendStyle==DRAW_ARROW )
     {
      SetIndexArrow(0,TrendArrow);
      SetIndexArrow(1,TrendArrow);
      SetIndexArrow(2,TrendArrow);
      SetIndexArrow(3,TrendArrow);
     }
   else TrendStyle=DRAW_LINE;
   if( FletStyle==DRAW_ARROW )
     {
      SetIndexArrow(4,FletArrow);
      SetIndexArrow(5,FletArrow);
     }
   else FletStyle=DRAW_LINE;
   if( AxeStyle==DRAW_ARROW ) SetIndexArrow(6,AxeArrow);
   else AxeStyle=DRAW_LINE;
//----
   VerySmallValue=0.1*Point;                           //  (double)
   VeryBigValue=9999999;                               //  (double)
   if( TotalBars<1 || TotalBars>Bars ) TotalBars=Bars; //   
   if( WidthMax<VerySmallValue ) Shift=VeryBigValue;   //   
   else Shift=0.5*WidthMax*Point+VerySmallValue;       //   
   if( SpeedMin<VerySmallValue ) SpeedMin=0;           //   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int Bar1=TotalBars-1, Bar2, Bar;
   double Price1, Price2, Price, min, max, Speed;
   string Message;
//----
   while( Bar1>=0 )
     {
      Price1=0.5*(High[Bar1]+Low[Bar1]);
      Price=Price1;             //     
      Speed=0;
      Bar2=Bar1;
      while( Bar2>=0 )
        {                        //  
         Price2=0.5*(High[Bar2]+Low[Bar2]);
         if( High[Bar2]>Price+Speed+Shift || Low[Bar2]<Price+Speed-Shift ) break;
         if( Bar2>0 )
           {
            Price=Price2;
            if( Bar1>Bar2 ) Speed=(Price2-Price1)/(Bar1-Bar2);
           }
         Bar2--;
        }
      if( Bar2<0 ) Bar2=0;       //  :     
      if( Bar1<=Bar2 )
        {
         Bar1--;
         continue;               //   
        }
      if( Price2>Price+Speed+Shift || Price2<Price+Speed-Shift )
         if( Bar1>Bar2+1 )       //     
           {                     //     
            Bar2++;
            Price2=Price;       //    
           }
         else
           {                     //     
            Bar1--;
            continue;            //   
           }
      Speed=(Price2-Price1)/(Point*(Bar1-Bar2));
      min=VeryBigValue;
      max=0;
      Bar=Bar2+1;
      while( Bar<=Bar1 )
        {
         if( min>Low[Bar] ) min=Low[Bar];
         if( max<High[Bar] ) max=High[Bar];
         Bar++;
        }
      while( Bar>Bar2 )
        {                        //  
         Bar--;
         Price=Price1+Speed*(Bar1-Bar)*Point;
         if( ShowAxe ) Axe[Bar]=Price; // 
         if( Speed>SpeedMin )
           {                     // 
            if( ShowTrend )
              {
               UH[Bar]=Price+Shift;
               UL[Bar]=Price-Shift;
              }
           }
         else if( -Speed>SpeedMin )
           {                     // 
            if( ShowTrend )
              {
               DH[Bar]=Price+Shift;
               DL[Bar]=Price-Shift;
              }
           }
         else if( ShowFlet )
           {                     // 
            FH[Bar]=max;
            FL[Bar]=min;
           }
        }
      Bar1=Bar2;                 //  
     }
   Comment(Message);
   WindowRedraw();
//----
   return(0);
  }
//+------------------------------------------------------------------+